---
title: Web Workers API
slug: Web/API/Web_Workers_API
tags:
  - API
  - Overview
  - Reference
  - Web Workers
---
<div>{{DefaultAPISidebar("Web Workers API")}}</div>

<p class="summary"><strong>Web Workers</strong> makes it possible to run a script operation in a background thread separate from the main execution thread of a web application. The advantage of this is that laborious processing can be performed in a separate thread, allowing the main (usually the UI) thread to run without being blocked/slowed down.</p>

<div class="notecard note">
<p class="summary"><strong>Note:</strong> Web Workers can also use the Web Worker API (i.e. workers can spawn workers, provided they are hosted within the same <a href="/en-US/docs/Glossary/origin">origin</a> as the parent page). </p>
</div>

<h2 id="Web_Workers_concepts_and_usage">Web Workers concepts and usage</h2>

<p>A worker is an object created using a constructor (e.g. {{DOMxRef("Worker.Worker", "Worker()")}}) that runs a named JavaScript file — this file contains the code that will run in the worker thread.</p>

<p>In addition to the standard <a href="/en-US/docs/Web/JavaScript">JavaScript</a> set of functions (such as <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/String"><code>String</code></a>, <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array"><code>Array</code></a>, <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object"><code>Object</code></a>, <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/JSON"><code>JSON</code></a>, etc.), you can run almost any code you like inside a worker thread. There are some exceptions: for example, you can't directly manipulate the DOM from inside a worker, or use some default methods and properties of the <a href="/en-US/docs/Web/API/Window"><code>window</code></a> object. For information about the code that you <em>can </em>run see <a href="#Worker_global_contexts_and_functions">worker global context and functions</a>, and <a href="#Supported_Web_APIs">supported web APIs</a> below.</p>

<p>Data is sent between workers and the main thread via a system of messages — both sides send their messages using the <code>postMessage()</code> method, and respond to messages via the <code>onmessage</code> event handler (the message is contained within the {{Event("Message")}} event's <code>data</code> property). The data is copied rather than shared.</p>

<p>Workers may in turn spawn new workers, as long as those workers are hosted within the same {{glossary("origin")}} as the parent page. In addition, workers may use <a class="internal" href="/en-US/docs/Web/API/XMLHttpRequest"><code>XMLHttpRequest</code></a> for network I/O, with the exception that the <code>responseXML</code> and <code>channel</code> attributes on <code>XMLHttpRequest</code> always return <code>null</code>.</p>

<h3 id="Worker_types">Worker types</h3>

<p>There are a number of different types of workers:</p>

<ul>
 <li>Dedicated workers are workers that are utilized by a single script. This context is represented by either a {{DOMxRef("DedicatedWorkerGlobalScope")}} object.</li>
 <li>{{DOMxRef("SharedWorker","Shared workers")}} are workers that can be utilized by multiple scripts running in different windows, IFrames, etc., as long as they are in the same domain as the worker. They are a little more complex than dedicated workers — scripts must communicate via an active port.</li>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API">Service Workers</a> essentially act as proxy servers that sit between web applications, the browser, and the network (when available). They are intended, among other things, to enable the creation of effective offline experiences, intercept network requests and take appropriate action based on whether the network is available, and update assets residing on the server. They will also allow access to push notifications and background sync APIs.</li>
 <li>Chrome Workers are a Firefox-only type of worker that you can use if you are developing add-ons and want to use workers in extensions and have access to <a href="https://developer.mozilla.org/en/js-ctypes">js-ctypes</a> in your worker. See {{DOMxRef("ChromeWorker")}} for more details.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: As per the <a href="https://html.spec.whatwg.org/multipage/workers.html#runtime-script-errors-2">Web workers Spec</a>, worker error events should not bubble (see {{bug(1188141)}}. This has been implemented in Firefox 42.</p>
</div>

<h3 id="Worker_global_contexts_and_functions">Worker global contexts and functions</h3>

<p>Workers run in a different global context than the current <span>{{DOMxRef("window")}}</span>! While  {{domxref("Window")}} is not directly available to workers, many of the same methods are defined in a shared mixin ({{domxref("WindowOrWorkerGlobalScope")}}), and made available to workers through their own {{domxref("WorkerGlobalScope")}}-derived contexts: </p>

<ul>
 <li>{{domxref("DedicatedWorkerGlobalScope")}} for dedicated workers</li>
 <li>{{domxref("SharedWorkerGlobalScope")}} for shared workers</li>
 <li>{{domxref("ServiceWorkerGlobalScope")}} for <a href="/en-US/docs/Web/API/ServiceWorker_API">service workers</a></li>
</ul>

<p>Some of the functions (a subset) that are common to all workers and to the main thread (from {{domxref("WindowOrWorkerGlobalScope")}}) are: {{domxref("WindowBase64.atob", "atob()")}}, {{domxref("WindowBase64.btoa", "btoa()")}}, {{domxref("WindowTimers.clearInterval", "clearInterval()")}}, {{domxref("WindowTimers.clearTimeout", "clearTimeout()")}},{{domxref("Window.dump()", "dump()")}} {{non-standard_inline}}, {{domxref("WindowTimers.setInterval", "setInterval()")}}, {{domxref("WindowTimers.setTimeout", "setTimeout()")}}.</p>

<p>The following functions are <strong>only </strong>available to workers:</p>

<ul>
 <li>{{domxref("WorkerGlobalScope.importScripts", "WorkerGlobalScope.importScripts()")}} (all workers), </li>
 <li>{{domxref("WorkerGlobalScope.close", "close()")}} {{non-standard_inline}} (dedicated and shared workers only), </li>
 <li>{{domxref("DedicatedWorkerGlobalScope.postMessage")}} (dedicated workers and <a href="/en-US/docs/Mozilla/Gecko/Chrome/API/ChromeWorker">chrome workers</a> only).</li>
</ul>

<h3 id="Supported_Web_APIs">Supported Web APIs</h3>

<div class="notecard note">
<p>Note that if a listed API is supported by a platform in a particular version, then it can generally be assumed to be available in web workers. You can also test support for a particular object/function using the site: <a href="https://worker-playground.glitch.me/">https://worker-playground.glitch.me/</a></p>
</div>

<p>The following Web APIs are available to workers: {{domxref("Barcode_Detection_API","Barcode Detection API")}}, {{domxref("Broadcast_Channel_API","Broadcast Channel API")}}, {{domxref("Cache", "Cache API")}}, {{domxref("Channel_Messaging_API", "Channel Messaging API")}},{{domxref("Console", "Console API")}}, <a href="/en-US/docs/Web/API/Web_Crypto_API">Web Crypto API</a> ({{domxref("Crypto")}}), {{domxref("CustomEvent")}}, {{domxref("Data_Store_API", "Data Store")}} (Firefox only), {{domxref("DOMRequest")}} and {{domxref("DOMCursor")}}, {{domxref("Encoding_API", "Encoding API")}} ({{domxref("TextEncoder")}}, {{domxref("TextDecoder")}}, etc.), {{domxref("Fetch_API", "Fetch API")}}, {{domxref("FileReader")}}, {{domxref("FileReaderSync")}} (only works in workers!), {{domxref("FormData")}}, {{domxref("ImageData")}}, {{domxref("IndexedDB_API", "IndexedDB")}}, <a href="/en-US/docs/Web/API/Network_Information_API">Network Information API</a>, {{domxref("Notifications_API", "Notifications API")}}, {{domxref("Performance_API","Performance API")}} (including: {{domxref("Performance")}}, {{domxref("PerformanceEntry")}}, {{domxref("PerformanceMeasure")}}, {{domxref("PerformanceMark")}}, {{domxref("PerformanceObserver")}}, {{domxref("PerformanceResourceTiming")}}), {{jsxref("Promise")}}, <a href="/en-US/docs/Web/API/Server-sent_events">Server-sent events</a>, {{domxref("ServiceWorkerRegistration")}}, {{ domxref("URL_API","URL API") }} (e.g. {{ domxref("URL") }}), <a href="/en-US/docs/Web/API/WebGL_API">WebGL</a> with {{domxref("OffscreenCanvas")}} (enabled behind a feature preference setting <code>gfx.offscreencanvas.enabled</code>), {{domxref("WebSocket")}}, {{domxref("XMLHttpRequest")}}.</p>

<p>Workers can also spawn other workers, so these APIs are also available: {{domxref("Worker")}}, {{domxref("WorkerGlobalScope")}}, {{domxref("WorkerLocation")}}, {{domxref("WorkerNavigator")}}.</p>

<h2 id="Web_Worker_interfaces">Web Worker interfaces</h2>

<dl>
 <dt>{{DOMxRef("AbstractWorker")}}</dt>
 <dd>Abstracts properties and methods common to all kind of workers (i.e. {{DOMxRef("Worker")}} or {{DOMxRef("SharedWorker")}}).</dd>
 <dt>{{DOMxRef("Worker")}}</dt>
 <dd>Represents a running worker thread, allowing you to pass messages to the running worker code.</dd>
 <dt>{{DOMxRef("WorkerLocation")}}</dt>
 <dd>Defines the absolute location of the script executed by the {{domxref("Worker")}}.</dd>
 <dt>{{DOMxRef("SharedWorker")}}</dt>
 <dd>Represents a specific kind of worker that can be <em>accessed</em> from several {{glossary("browsing context", "browsing contexts")}}, being several windows, iframes or even workers.</dd>
 <dt>{{DOMxRef("WorkerGlobalScope")}}</dt>
 <dd>Represents the generic scope of any worker (doing the same job as {{DOMxRef("Window")}} does for normal web content). Different types of worker have scope objects that inherit from this interface and add more specific features.</dd>
 <dt>{{DOMxRef("DedicatedWorkerGlobalScope")}}</dt>
 <dd>Represents the scope of a dedicated worker, inheriting from {{DOMxRef("WorkerGlobalScope")}} and adding some dedicated features.</dd>
 <dt>{{DOMxRef("SharedWorkerGlobalScope")}}</dt>
 <dd>Represents the scope of a shared worker, inheriting from {{DOMxRef("WorkerGlobalScope")}} and adding some dedicated features.</dd>
 <dt>{{DOMxRef("WorkerNavigator")}}</dt>
 <dd>Represents the identity and state of the user agent (the client):</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>We have created a couple of simple demos to show basic usage:</p>

<ul>
 <li><a href="https://github.com/mdn/simple-web-worker">Basic dedicated worker example</a> (<a href="https://mdn.github.io/simple-web-worker/">run dedicated worker</a>).</li>
 <li><a href="https://github.com/mdn/simple-shared-worker">Basic shared worker example</a> (<a href="https://mdn.github.io/simple-shared-worker/">run shared worker</a>).</li>
</ul>

<p>You can find out more information on how these demos work in <a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">Using Web Workers</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "workers.html#workers", "Web Workers")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Web_Workers_API/Using_web_workers">Using Web Workers</a></li>
 <li>{{domxref("Worker")}} interface</li>
 <li>{{domxref("SharedWorker")}} interface</li>
 <li><a href="/en-US/docs/Web/API/Service_Worker_API">Service Worker API</a></li>
 <li><a href="/en-US/docs/Web/API/ChromeWorker">ChromeWorker</a>: for using workers in privileged/chrome code</li>
</ul>
